#!/bin/sh
# Begin libexec.sh

#
#
#
#
# - getpidlist
# - evaluate_retval
#

# INCLUDE
include pretty
include common

#
# === Begin Code
#

depends ps sleep kill pidof print_status


getpidlist()
{
	usage_string="usage: $FUNCNAME {command}"

	if [ "$#" == "0" ]
	then
		echo "$FUNCNAME: called without arguments."
		echo "$usage_string"
		return 1
	fi

	base=$(basename $1)

	pidlist=$(/bin/pidof -o $$ -o $PPID -o %PPID -x $base)

	pid=""

	for apid in $pidlist
	do
		if [ -d /proc/$apid ]
		then
			pid="$pid $apid"
		fi	
	done

	echo $pid
};

evaluate_retval()
{

	retval=$?
	function_name="evaluate_retval"
	usage_string="usage: $function_name {short|long} [string]"

	if [ "$1" != "short" ] && [ "$1" != "long" ]
	then
		echo "$function_name: '$1' is bad first arguments, try : short long"
		echo $usage_string
		return 1
	fi

        if [ "$retval" == "0" ]
        then
                print_status success $1 $2
		return 0
        else
                print_status failure $1 $2
		return 1
        fi
}

kill_prog()
{
    # Depends on ps, sleep, kill

    usage="usage: $FUNCNAME {command}"
    
    if [ "$#" == "0" ]; then
	echo "$FUNCNAME: called without arguments."
	echo "$usage"
	return 1
    fi

    pid=$(getpidlist $*)

    kill -TERM $pid

    if ps h $pid >/dev/null 2>&1
    then
	sleep 2
        if /bin/ps h $pid > /dev/null 2>&1
        then
	    /bin/kill -KILL $pid
	    if /bin/ps h $pid > /dev/null 2>&1
	    then
		/usr/bin/sleep 2
	    fi
	fi
    fi

    ! /bin/ps h $pid >/dev/null 2>&1
};



# End libexec.sh
